%------------------TESTGAO.M
clear all
close all
randn('seed', 100)
n = 2^14; 
gam = 0.577126;
gas = exp(-gam);
%wavelet = 'Symmlet'; par = 4;
wavelet = 'Coiflet'; par = 3;
  lw = 3; 
  set(0, 'DefaultAxesFontSize', 16);
  fs = 16;
  msize = 6;


ts = rand_arma(n, [],[-0.3 -0.6 -0.3 0.6],1);
     ga1 = gao(ts,'a', 0.1, wavelet, par);
     ga2 = gao(ts,'h', 0,    wavelet, par);
     ga3 = gao(ts,'s', 0,    wavelet, par);
     %ga4 = gao(ts,'sh', 0,   wavelet, par);
omega = 0:0.005:pi;
the = 1/(2 * pi)* (abs( 1 - 0.3 * exp(-i * omega) - ...
      0.6 * exp(-i * 2 * omega) - 0.3 * exp( -i * 3 * omega) + ...
      0.6 * exp(-4 * i * omega) ) ).^2;
figure(1)
xs = linspace(0, pi, n/2);
plot( xs(2:end) , ga1(2:end)+gam,'-','linewidth',lw)
hold on
plot( xs(2:end) , ga2(2:end)+gam,'-.','linewidth',lw)
plot( xs(2:end) , ga3(2:end)+gam,':','linewidth',lw)
%plot( xs(2:end) , ga4(2:end)-log(2*pi)+gas,'--','linewidth',lw)
plot( omega, log(the), 'r--','linewidth',lw+1)
boxx= 0.9:0.01:1.1; boxy1=linspace(-1.3,-1.3, length(boxx));
                    boxy2=linspace(-0.7,-0.7, length(boxx));
plot(boxx,boxy1,boxx, boxy2, 'linewidth',lw-1)
boxy= -1.3:0.01:-0.7; boxx1=linspace(0.9,0.9, length(boxy));
                      boxx2=linspace(1.1, 1.1, length(boxy));
plot(boxx1,boxy,boxx2, boxy)
axis([0 pi -5 0])
xlabel('\omega', 'fontweight', 'bold', 'fontsize', fs)
ylabel('GAO-type Estimates', 'fontweight', 'bold', 'fontsize', fs)
legend('GAOA','GAOH','GAO','theor')
print -depsc 'C:\Brani\WorkGT\Marianna\Spect\testgaoma.eps'
%===============================================================
figure(2)
plot( xs(2:end) , ga1(2:end)+gam,'-','linewidth',lw)
hold on
plot( xs(2:end) , ga2(2:end)+gam,'-.','linewidth',lw)
plot( xs(2:end) , ga3(2:end)+gam,':','linewidth',lw)
plot( omega, log(the), 'r--','linewidth',lw+1)
axis([0.9  1.1  -1.3 -0.7])
legend('GAOA','GAOH','GAO','theor',4)
xlabel('\omega', 'fontweight', 'bold', 'fontsize', fs)
ylabel('GAO-type Estimates (detail)', 'fontweight', 'bold', 'fontsize', fs)
print -depsc 'C:\Brani\WorkGT\Marianna\Spect\testgaomadetail.eps'


