%------------------compare.M
clear all
close all

  lw = 2; 
  set(0, 'DefaultAxesFontSize', 16);
  fs = 16;
  msize = 5;

n = 2^14; 
kk =20; %number of runs
erbam = [];
ergao = [];
gam = 0.577126;
wavelet = 'Coiflet'; par = 3; 
for k = 1:kk;
    k
    randn('seed',k)
skew =  0.07;
ts = rand_arma(n, [0 0 0 0.9 0 0 0 0.7 0 0 0  -0.63] , [],1);
    gagao = gao(ts,'h', skew, wavelet, par);
    gabam = bam(ts, wavelet, par);

omega = linspace(0,pi,n/2);
  the = 1./(2 * pi* abs( 1 - 0.9 * exp(- i * 4 * omega) ...
   - 0.7 * exp(-i * 8 * omega) + 0.63 * exp( -i * 12 * omega) ).^2);

lthe = log(the(:));
theoryrun = lthe(2:end);
gabamrun = gabam(2:end)+gam;
gagaorun = gagao(2:end)+gam;

%================================================
erbam = [erbam mean((gabamrun - theoryrun).^2)];
ergao = [ergao mean((gagaorun - theoryrun).^2)];
end
figure(1)
plot( omega(2:end) , gabamrun,'r-','linewidth', lw)
hold on
plot( omega(2:end) , gagaorun,'g-','linewidth', lw)
plot( omega(2:end),  theoryrun, 'b-','linewidth', lw)
print -depsc 'C:\Brani\WorkGT\Marianna\Spect\compare1.eps'



figure(2)
plot( (1:kk),erbam, 'r-','linewidth', lw)
hold on
plot( (1:kk), ergao, 'g-','linewidth', lw)
plot( (1:kk), mean(erbam).*ones(1,kk), 'r--','linewidth', lw )
plot( (1:kk), mean(ergao).*ones(1,kk), 'g--' ,'linewidth', lw)
print -depsc 'C:\Brani\WorkGT\Marianna\Spect\compare2.eps'

var(erbam - mean(erbam))
var(ergao - mean(ergao))