%------------------TESTBAMAR.M
close all
clear all
n = 2^14; 
randn('seed',2)
  lw = 2; 
  set(0, 'DefaultAxesFontSize', 15);
  fs = 15;
  msize = 5;
  gam = 0.577126;
  gas = exp(-gam);

ts = rand_arma(n, [0 0 0 0.9 0 0 0 0.7 0 0 0  -0.63] , [], 1);
    ga = bam(ts, 'Coiflet',2);
    omega = linspace(0,pi,n/2);
    %we take Wahba's template AR TS.
  the = 1./(2 * pi* abs( 1 - 0.9 * exp(- i * 4 * omega) ...
   - 0.7 * exp(-i * 8 * omega) + 0.63 * exp( -i * 12 * omega) ).^2);
the=the(:);
figure(1)
xs = linspace(0, pi, n/2);
plot( xs(2:end) , ga(2:end)+gam,'r-','linewidth',lw)
hold on
plot( omega, log(the), 'b--','linewidth',lw)
xlabel('\omega', 'fontweight', 'bold', 'fontsize', fs)
ylabel('BAM Estimate', 'fontweight', 'bold', 'fontsize', fs)
axis([0 pi -4 6])
print -depsc 'C:\Brani\WorkGT\Marianna\Spect\testbamar.eps'

%error
1/(n/2 - 1) * sum(ga(2:end)+gam- log(the(2:end)) ).^2