%------------------TESTGAOAR.M
  clear all
  close all
  randn('seed',2)
  lw = 2.0; 
  set(0, 'DefaultAxesFontSize', 15);
  fs = 15;
  msize = 5;
  gam = 0.577126;
  gas = exp(-gam);
skew=0;
n = 2^14; skew =   0.1;
ts = rand_arma(n, [0 0 0 0.9 0 0 0 0.7 0 0 0  -0.63] , [],1);
    %ts = randn(2^14,1);
    %ga = gao(ts, 'Symmlet', 4 );
   %ga = gao(ts, 'Coiflet',3);
    ga = gao(ts,'h', skew, 'Coiflet',2);
    %ga = yao(ts, 'Symmlet',4);

omega = linspace(0,pi,n/2);
    %the = 1/(2*pi)*ones(size(omega));
    %we take Wahba's template, the MA(
  the = 1./(2 * pi* abs( 1 - 0.9 * exp(- i * 4 * omega) ...
   - 0.7 * exp(-i * 8 * omega) + 0.63 * exp( -i * 12 * omega) ).^2);
the=the(:);
figure(1)
xs = linspace(0, pi, n/2);
plot( xs(2:end) , ga(2:end)+gam,'r-','linewidth',lw)
hold on
plot( omega, log(the), 'b--', 'linewidth', lw)
xlabel('\omega', 'fontweight', 'bold', 'fontsize', fs)
ylabel('Gao''s Estimate', 'fontweight', 'bold', 'fontsize', fs)
axis([0 pi -4 6])
print -depsc 'C:\Brani\WorkGT\Marianna\Spect\testgaoar.eps'

%error
1/(n/2 - 1) * sum(ga(2:end)-log(2*pi)+gas - log(the(2:end)) ).^2    
    

